现在的位置: 首页 > 综合 > 正文

HDU/HDOJ 2333 Assemble Northwestern Europe 2007

2017年11月22日 ⁄ 综合 ⁄ 共 2903字 ⁄ 字号 评论关闭

 

Assemble

Time Limit : 3000/1000ms (Java/Other)   Memory Limit : 65536/32768K (Java/Other)
Total Submission(s) : 12   Accepted Submission(s) : 1

Font: Times New Roman | Verdana | Georgia

Font Size:  

Problem Description

Recently your team noticed that the computer you use to practice for programming contests is not good enough anymore. Therefore, you decide to buy a new computer.

To make the ideal computer for your needs, you decide to buy separate components and assemble the computer yourself. You need to buy exactly one of each type of component.

The problem is which components to buy. As you all know, the quality of a computer is equal to the quality of its weakest component. Therefore, you want to maximize the quality of the component with the lowest quality, while not exceeding your budget.

Input

On the first line one positive number: the number of testcases, at most 100. After that per testcase:

One line with two integers: 1 ≤ n ≤ 1 000, the number of available components and 1 ≤ b ≤ 1 000 000 000, your budget.

n lines in the following format: “type name price quality”, where type is a string with the type of the component, name is a string with the unique name of the component, price is an integer (0 ≤ price ≤ 1 000 000) which represents the price of the component
and quality is an integer (0 ≤ quality ≤ 1 000 000 000) which represents the quality of the component (higher is better). The strings contain only letters, digits and underscores and have a maximal length of 20 characters.

Output

Per testcase:

One line with one integer: the maximal possible quality.

Sample Input

1
18 800
processor 3500_MHz 66 5
processor 4200_MHz 103 7
processor 5000_MHz 156 9
processor 6000_MHz 219 12
memory 1_GB 35 3
memory 2_GB 88 6
memory 4_GB 170 12
mainbord all_onboard 52 10
harddisk 250_GB 54 10
harddisk 500_FB 99 12
casing midi 36 10
monitor 17_inch 157 5
monitor 19_inch 175 7
monitor 20_inch 210 9
monitor 22_inch 293 12
mouse cordless_optical 18 12
mouse microsoft 30 9
keyboard office 4 10

Sample Output

9

Source

Northwestern Europe 2007

 

题意不用说,求最大的最小。

这种题很容易联想到二分检索技术。

这个题也一样,就是二分一个答案,然后贪心判定。

我先前TLE了3次,原因是忘记把数组初始化。。

后来又持续WA,理由是我的贪心判定各种囧。。Orz啊。。

 

我的代码:

#pragma warning(disable:4786)
#include<stdio.h>
#include<algorithm>
#include<string.h>
#include<vector>
#include<map>
#include<string>

using namespace std;

struct node
{
	char type[40];
	char name[40];
	int money;
	int qua;
};
node com[1005];
int n,m,num;
map<string,int>my;
vector<node>tree[1005];
int maxq;

bool check(int x)
{
	int i,j,temp,sum=0;
	bool flag;
	for(i=1;i<=num;i++)
	{
		temp=1e9+1;
		flag=true;
		for(j=0;j<tree[i].size();j++)
		{
			if(tree[i][j].qua>=x)
			{
				flag=false;
				if(temp>tree[i][j].money)
					temp=tree[i][j].money;
			}
		}
		if(flag)
			return false;
		sum=sum+temp;
	}
	if(sum>m)
		return false;
	else
		return true;
}

void solve()
{
	int left,right,mid,ans=0;
	left=0,right=maxq;
	while(left<=right)
	{
		mid=(left+right)>>1;
		if(check(mid))
		{
			left=mid+1;
			ans=mid;
		}
		else
		{
			right=mid-1;
		}
	}
	printf("%d\n",ans);
}

void init()
{
	int i;
	for(i=0;i<1005;i++)
		tree[i].clear();
	my.clear();
}

int main()
{
	int t,i;
	scanf("%d",&t);
	while(t--)
	{
		num=0,maxq=0;
		init();
		scanf("%d%d",&n,&m);
		for(i=1;i<=n;i++)
		{
			scanf("%s%s%d%d",com[i].type,com[i].name,&com[i].money,&com[i].qua);
			if(!my[com[i].type])
			{
				num++;
				my[com[i].type]=num;
			}
			tree[my[com[i].type]].push_back(com[i]);
			if(com[i].qua>maxq)
				maxq=com[i].qua;
		}
		solve();
	}
	return 0;
}

抱歉!评论已关闭.